﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.IO;
using System.Xml;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void btnSelectFile_Click(object sender, EventArgs e)
    {
        if (!txtFilePath.Text.Equals(string.Empty))
        {
            Session["CurrentXMLFile"] = txtFilePath.Text;
            txtEditXML.Text = string.Empty;//reset textbox to edit xml
            LoadXMLTree(txtFilePath.Text);
        }
    }

    private void LoadXMLTree(string fileName)
    {
        try
        {
            xmlDataSource.DataFile = fileName;
            xmlDataSource.EnableCaching = false;
            xmlTreeView.DataSourceID = "xmlDataSource";
            xmlTreeView.DataBind();
        }
        catch (Exception ex)
        {
            lblMessage.Text = "Exception: " + ex.Message;
        }
    }

    protected void xmlTreeView_SelectedNodeChanged(object sender, EventArgs e)
    {
        XmlDocument doc = new XmlDocument();
        doc.Load(Server.MapPath(Session["CurrentXMLFile"].ToString()));
        XmlNode node = doc.SelectSingleNode(xmlTreeView.SelectedNode.DataPath);        
        txtEditXML.Text = node.InnerXml;
        Session["CurrentEditXpath"] = xmlTreeView.SelectedNode.DataPath;
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Session["CurrentEditXpath"] != null)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(Server.MapPath(Session["CurrentXMLFile"].ToString()));
            XmlNode node = doc.SelectSingleNode(Session["CurrentEditXpath"].ToString());
            node.InnerXml = txtEditXML.Text;
            doc.Save(Server.MapPath(Session["CurrentXMLFile"].ToString()));
            LoadXMLTree(Server.MapPath(Session["CurrentXMLFile"].ToString()));
            lblMessage.Text = "XML file modified successfully!";
        }
        else
        {
            lblMessage.Text = "Please select a node to edit.";
        }
    }


}
